net.minecraft.entity.player

## Class EntityPlayer

- java.lang.Object
- - net.minecraft.entity.Entity
  - - net.minecraft.entity.EntityLivingBase
    - - net.minecraft.entity.player.EntityPlayer

- All Implemented Interfaces:
    ICommandSender
  Direct Known Subclasses:
    AbstractClientPlayer, EntityPlayerMP, FakePlayer

      public abstract class EntityPlayer
      extends EntityLivingBase
      implements ICommandSender

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `float` | `cameraYaw`
    `PlayerCapabilities` | `capabilities` The player's capabilities.
    `float` | `experience` The current amount of experience the player has within their Experience Bar.
    `int` | `experienceLevel` The current experience level the player is on.
    `int` | `experienceTotal` The total amount of experience the player has.
    `float` | `eyeHeight`
    `float` | `field_71079_bU`
    `float` | `field_71082_cx`
    `double` | `field_71085_bR`
    `float` | `field_71089_bV`
    `double` | `field_71091_bM`
    `double` | `field_71094_bP`
    `double` | `field_71095_bQ`
    `double` | `field_71096_bN`
    `double` | `field_71097_bO`
    `EntityFishHook` | `fishEntity` An instance of a fishing rod's hook.
    `InventoryPlayer` | `inventory` Inventory of the player
    `Container` | `inventoryContainer` The Container for the player's inventory (which opens when they press E)
    `Container` | `openContainer` The Container the player has open.
    `static String` | `PERSISTED_NBT_TAG`
    `ChunkCoordinates` | `playerLocation` The chunk coordinates of the bed the player is in (null if player isn't in a bed).
    `float` | `prevCameraYaw`
    `int` | `sleepTimer`
    `String` | `username`
    `int` | `xpCooldown` Used by EntityPlayer to prevent too many xp orbs from getting absorbed at once.

    - ### Fields inherited from class net.minecraft.entity.EntityLivingBase

      `arrowHitTimer, attackedAtYaw, attackTime, cameraPitch, deathTime, field_70769_ao, field_70770_ap, hurtTime, isSwingInProgress, jumpMovementFactor, limbSwing, limbSwingAmount, maxHurtResistantTime, maxHurtTime, moveForward, moveStrafing, prevCameraPitch, prevHealth, prevLimbSwingAmount, prevRenderYawOffset, prevRotationYawHead, prevSwingProgress, renderYawOffset, rotationYawHead, swingProgress, swingProgressInt`

    - ### Fields inherited from class net.minecraft.entity.Entity

      `addedToChunk, boundingBox, capturedDrops, captureDrops, chunkCoordX, chunkCoordY, chunkCoordZ, dimension, distanceWalkedModified, distanceWalkedOnStepModified, entityCollisionReduction, entityId, fallDistance, field_70135_K, fireResistance, forceSpawn, height, hurtResistantTime, ignoreFrustumCheck, isAirBorne, isCollided, isCollidedHorizontally, isCollidedVertically, isDead, lastTickPosX, lastTickPosY, lastTickPosZ, motionX, motionY, motionZ, myEntitySize, noClip, onGround, posX, posY, posZ, prevDistanceWalkedModified, preventEntitySpawning, prevPosX, prevPosY, prevPosZ, prevRotationPitch, prevRotationYaw, renderDistanceWeight, riddenByEntity, ridingEntity, rotationPitch, rotationYaw, serverPosX, serverPosY, serverPosZ, stepHeight, ticksExisted, timeUntilPortal, velocityChanged, width, worldObj, yOffset, ySize`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `EntityPlayer(World par1World, String par2Str)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addChatMessage(String par1Str)` Add a chat message to the player
    `void` | `addExhaustion(float par1)` increases exhaustion level by supplied amount
    `void` | `addExperience(int par1)` This method increases the player's current amount of experience.
    `void` | `addExperienceLevel(int par1)` Add experience levels to this player.
    `void` | `addMovementStat(double par1, double par3, double par5)` Adds a value to a movement statistic field - like run, walk, swin or climb.
    `void` | `addScore(int par1)` Add to player's score
    `void` | `addStat(StatBase par1StatBase, int par2)` Adds a value to a statistic field.
    `void` | `addToPlayerScore(Entity par1Entity, int par2)` Adds a value to the player score.
    `boolean` | `attackEntityFrom(DamageSource par1DamageSource, float par2)` Called when the entity is attacked.
    `void` | `attackTargetEntityWithCurrentItem(Entity par1Entity)` Attacks for the player the targeted entity with the currently equipped item.
    `boolean` | `canAttackPlayer(EntityPlayer par1EntityPlayer)`
    `boolean` | `canEat(boolean par1)`
    `boolean` | `canHarvestBlock(Block par1Block)` Checks if the player has the ability to harvest a block (checks current inventory item for a tool if necessary)
    `boolean` | `canPlayerEdit(int par1, int par2, int par3, int par4, ItemStack par5ItemStack)`
    `void` | `clearItemInUse()`
    `void` | `clonePlayer(EntityPlayer par1EntityPlayer, boolean par2)` Copies the values from the given player into this player if boolean par2 is true.
    `void` | `closeScreen()` sets current screen to null (used on escape buttons of GUIs)
    `void` | `destroyCurrentEquippedItem()` Destroys the currently equipped item from the player's inventory.
    `void` | `displayGUIAnvil(int par1, int par2, int par3)` Displays the GUI for interacting with an anvil.
    `void` | `displayGUIBeacon(TileEntityBeacon par1TileEntityBeacon)` Displays the GUI for interacting with a beacon.
    `void` | `displayGUIBook(ItemStack par1ItemStack)` Displays the GUI for interacting with a book.
    `void` | `displayGUIBrewingStand(TileEntityBrewingStand par1TileEntityBrewingStand)` Displays the GUI for interacting with a brewing stand.
    `void` | `displayGUIChest(IInventory par1IInventory)` Displays the GUI for interacting with a chest inventory.
    `void` | `displayGUIDispenser(TileEntityDispenser par1TileEntityDispenser)` Displays the dipsenser GUI for the passed in dispenser entity.
    `void` | `displayGUIEditSign(TileEntity par1TileEntity)` Displays the GUI for editing a sign.
    `void` | `displayGUIEnchantment(int par1, int par2, int par3, String par4Str)`
    `void` | `displayGUIFurnace(TileEntityFurnace par1TileEntityFurnace)` Displays the furnace GUI for the passed in furnace entity.
    `void` | `displayGUIHopper(TileEntityHopper par1TileEntityHopper)`
    `void` | `displayGUIHopperMinecart(EntityMinecartHopper par1EntityMinecartHopper)`
    `void` | `displayGUIHorse(EntityHorse par1EntityHorse, IInventory par2IInventory)`
    `void` | `displayGUIMerchant(IMerchant par1IMerchant, String par2Str)`
    `void` | `displayGUIWorkbench(int par1, int par2, int par3)` Displays the crafting GUI for a workbench.
    `EntityItem` | `dropOneItem(boolean par1)` Called when player presses the drop item key
    `EntityItem` | `dropPlayerItem(ItemStack par1ItemStack)` Args: itemstack - called when player drops an item stack that's not in his inventory (like items still placed in a workbench while the workbench'es GUI gets closed)
    `EntityItem` | `dropPlayerItemWithRandomChoice(ItemStack par1ItemStack, boolean par2)` Args: itemstack, flag
    `float` | `getAbsorptionAmount()`
    `float` | `getAIMoveSpeed()` the movespeed used for the new AI system
    `boolean` | `getAlwaysRenderNameTagForRender()`
    `float` | `getArmorVisibility()` When searching for vulnerable players, if a player is invisible, the return value of this is the chance of seeing them anyway.
    `ChunkCoordinates` | `getBedLocation()` Deprecated.
    `ChunkCoordinates` | `getBedLocation(int dimension)` A dimension aware version of getBedLocation.
    `float` | `getBedOrientationInDegrees()`
    `String` | `getCommandSenderName()` Gets the name of this command sender (usually username, but possibly "Rcon")
    `ItemStack` | `getCurrentArmor(int par1)`
    `ItemStack` | `getCurrentEquippedItem()` Returns the currently being used item by the player.
    `ItemStack` | `getCurrentItemOrArmor(int par1)` 0 = item, 1-n is armor
    `float` | `getCurrentPlayerStrVsBlock(Block par1Block, boolean par2)` Deprecated.
    `float` | `getCurrentPlayerStrVsBlock(Block par1Block, boolean par2, int meta)`
    `float` | `getDefaultEyeHeight()` Returns the default eye height of the player
    `String` | `getDisplayName()` Get the currently computed display name, cached for efficiency.
    `String` | `getEntityName()` Gets the username of the entity.
    `World` | `getEntityWorld()`
    `float` | `getEyeHeight()`
    `FoodStats` | `getFoodStats()` Returns the player's FoodStats object.
    `ItemStack` | `getHeldItem()` Returns the item that this EntityLiving is holding, if any.
    `boolean` | `getHideCape()`
    `InventoryEnderChest` | `getInventoryEnderChest()` Returns the InventoryEnderChest of this player.
    `Icon` | `getItemIcon(ItemStack par1ItemStack, int par2)`
    `ItemStack` | `getItemInUse()`
    `int` | `getItemInUseCount()`
    `int` | `getItemInUseDuration()`
    `ItemStack[]` | `getLastActiveItems()`
    `int` | `getMaxInPortalTime()` Return the amount of time this entity should stay in a portal before being transported.
    `int` | `getPortalCooldown()` Return the amount of cooldown before this entity can use a portal again.
    `int` | `getScore()`
    `int` | `getSleepTimer()`
    `Team` | `getTeam()`
    `int` | `getTotalArmorValue()` Returns the current armor value as determined by a call to InventoryPlayer.getTotalArmorValue
    `String` | `getTranslatedEntityName()` Returns the translated name of the entity.
    `Scoreboard` | `getWorldScoreboard()`
    `double` | `getYOffset()` Returns the Y Offset of this entity.
    `void` | `handleHealthUpdate(byte par1)`
    `boolean` | `interactWith(Entity par1Entity)`
    `boolean` | `isBlocking()`
    `boolean` | `isCurrentToolAdventureModeExempt(int par1, int par2, int par3)` Returns true if the given block can be mined with the current tool in adventure mode.
    `boolean` | `isEntityInsideOpaqueBlock()` Checks if this entity is inside of an opaque block
    `boolean` | `isInvisibleToPlayer(EntityPlayer par1EntityPlayer)`
    `boolean` | `isPlayerFullyAsleep()` Returns whether or not the player is asleep and the screen has fully faded.
    `boolean` | `isPlayerSleeping()` Returns whether player is sleeping or not
    `boolean` | `isPushedByWater()`
    `boolean` | `isSpawnForced()` Deprecated.
    `boolean` | `isSpawnForced(int dimension)` A dimension aware version of isSpawnForced.
    `boolean` | `isUsingItem()` Checks if the entity is currently using an item (e.g., bow, food, sword) by holding down the useItemButton
    `void` | `joinEntityItemWithWorld(EntityItem par1EntityItem)` Joins the passed in entity item with the world.
    `void` | `mountEntity(Entity par1Entity)` Called when a player mounts an entity.
    `void` | `moveEntityWithHeading(float par1, float par2)` Moves the entity based on the specified heading.
    `void` | `onCriticalHit(Entity par1Entity)` Called when the player performs a critical hit on the Entity.
    `void` | `onDeath(DamageSource par1DamageSource)` Called when the mob's health reaches 0.
    `void` | `onEnchantmentCritical(Entity par1Entity)`
    `void` | `onKillEntity(EntityLivingBase par1EntityLivingBase)` This method gets called when the entity kills another one.
    `void` | `onLivingUpdate()` Called frequently so the entity can update its state every tick as required.
    `void` | `onUpdate()` Called to update the entity's position/logic.
    `void` | `openGui(Object mod, int modGuiId, World world, int x, int y, int z)`
    `void` | `playSound(String par1Str, float par2, float par3)`
    `void` | `preparePlayerToSpawn()`
    `void` | `readEntityFromNBT(NBTTagCompound par1NBTTagCompound)` (abstract) Protected helper method to read subclass entity data from NBT.
    `void` | `refreshDisplayName()` Force the displayed name to refresh
    `void` | `respawnPlayer()`
    `void` | `sendPlayerAbilities()` Sends the player's abilities to the server (if there is one).
    `void` | `setAbsorptionAmount(float par1)`
    `void` | `setCurrentItemOrArmor(int par1, ItemStack par2ItemStack)` Sets the held item, or an armor slot.
    `void` | `setDead()` Will get destroyed next tick.
    `void` | `setGameType(EnumGameType par1EnumGameType)` Sets the player's game mode and sends it to them.
    `void` | `setInWeb()` Sets the Entity inside a web block.
    `void` | `setItemInUse(ItemStack par1ItemStack, int par2)` sets the itemInUse when the use item button is clicked.
    `void` | `setScore(int par1)` Set player's score
    `void` | `setSpawnChunk(ChunkCoordinates par1ChunkCoordinates, boolean par2)` Defines a spawn coordinate to player spawn.
    `void` | `setSpawnChunk(ChunkCoordinates chunkCoordinates, boolean forced, int dimension)` A dimension aware version of setSpawnChunk.
    `boolean` | `shouldHeal()` Checks if the player's health is not full and not zero.
    `EnumStatus` | `sleepInBedAt(int par1, int par2, int par3)` Attempts to have the player sleep in a bed at the specified location.
    `void` | `stopUsingItem()`
    `void` | `triggerAchievement(StatBase par1StatBase)` Will trigger the specified trigger.
    `void` | `updateRidden()` Handles updating while being ridden by an entity
    `static ChunkCoordinates` | `verifyRespawnCoordinates(World par0World, ChunkCoordinates par1ChunkCoordinates, boolean par2)` Ensure that a block enabling respawning exists at the specified coordinates and find an empty space nearby to spawn.
    `void` | `wakeUpPlayer(boolean par1, boolean par2, boolean par3)` Wake up the player if they're sleeping.
    `void` | `writeEntityToNBT(NBTTagCompound par1NBTTagCompound)` (abstract) Protected helper method to write subclass entity data to NBT.
    `int` | `xpBarCap()` This method returns the cap amount of experience that the experience bar can hold.

    - ### Methods inherited from class net.minecraft.entity.EntityLivingBase

      `addPotionEffect, attackEntityAsMob, canBeCollidedWith, canBePushed, canBreatheUnderwater, canEntityBeSeen, clearActivePotions, curePotionEffects, dismountEntity, func_110142_aN, func_142015_aE, func_94060_bK, getActivePotionEffect, getActivePotionEffects, getAge, getAITarget, getArrowCountInEntity, getAttributeMap, getCreatureAttribute, getEntityAttribute, getHealth, getLastAttacker, getLastAttackerTime, getLook, getLookVec, getMaxHealth, getPosition, getRNG, getRotationYawHead, getSwingProgress, heal, isChild, isClientWorld, isEntityAlive, isEntityUndead, isOnLadder, isOnSameTeam, isOnTeam, isPotionActive, isPotionActive, isPotionApplicable, knockBack, onEntityUpdate, onItemPickup, performHurtAnimation, rayTrace, removePotionEffect, removePotionEffectClient, renderBrokenItemStack, setAIMoveSpeed, setArrowCountInEntity, setHealth, setJumping, setLastAttacker, setPositionAndRotation2, setPositionAndUpdate, setRevengeTarget, setRotationYawHead, setSprinting, shouldRiderFaceForward, swingItem`

    - ### Methods inherited from class net.minecraft.entity.Entity

      `addEntityCrashInfo, addVelocity, applyEntityCollision, canAttackWithItem, canRenderOnFire, canRiderInteract, copyDataFrom, copyLocationAndAnglesFrom, doesEntityNotTriggerPressurePlate, dropItem, dropItemWithOffset, entityDropItem, equals, extinguish, getAir, getBlockExplosionResistance, getBoundingBox, getBrightness, getBrightnessForRender, getCollisionBorderSize, getCollisionBox, getDataWatcher, getDistance, getDistanceSq, getDistanceSqToEntity, getDistanceToEntity, getEntityData, getExtendedProperties, getMaxSafePointTries, getMountedYOffset, getParts, getPersistentID, getPickedResult, getShadowSize, getTeleportDirection, getUniqueID, handleLavaMovement, handleWaterMovement, hashCode, hitByEntity, interactFirst, isBurning, isCreatureType, isEating, isEntityEqual, isEntityInvulnerable, isImmuneToFire, isInRangeToRenderDist, isInRangeToRenderVec3D, isInsideOfMaterial, isInvisible, isInWater, isOffsetPositionInLiquid, isRiding, isSneaking, isSprinting, isWet, moveEntity, moveFlying, onChunkLoad, onCollideWithPlayer, onStruckByLightning, readFromNBT, registerExtendedProperties, resetEntityId, setAir, setAngles, setEating, setFire, setInPortal, setInvisible, setLocationAndAngles, setPosition, setPositionAndRotation, setSneaking, setVelocity, setWorld, shouldDismountInWater, shouldExplodeBlock, shouldRenderInPass, shouldRiderSit, toString, travelToDimension, updateRiderPosition, writeMountToNBT, writeToNBT, writeToNBTOptional`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.minecraft.command.ICommandSender

      `canCommandSenderUseCommand, getPlayerCoordinates, sendChatToPlayer`

- - ### Field Detail

    - #### PERSISTED_NBT_TAG

          public static final String PERSISTED_NBT_TAG

      See Also:
        Constant Field Values

    - #### inventory

          public InventoryPlayer inventory

      Inventory of the player

    - #### inventoryContainer

          public Container inventoryContainer

      The Container for the player's inventory (which opens when they press E)

    - #### openContainer

          public Container openContainer

      The Container the player has open.

    - #### prevCameraYaw

          public float prevCameraYaw

    - #### cameraYaw

          public float cameraYaw

    - #### username

          public final String username

    - #### xpCooldown

          public int xpCooldown

      Used by EntityPlayer to prevent too many xp orbs from getting absorbed at once.

    - #### field_71091_bM

          public double field_71091_bM

    - #### field_71096_bN

          public double field_71096_bN

    - #### field_71097_bO

          public double field_71097_bO

    - #### field_71094_bP

          public double field_71094_bP

    - #### field_71095_bQ

          public double field_71095_bQ

    - #### field_71085_bR

          public double field_71085_bR

    - #### playerLocation

          public ChunkCoordinates playerLocation

      The chunk coordinates of the bed the player is in (null if player isn't in a bed).

    - #### sleepTimer

          public int sleepTimer

    - #### field_71079_bU

          public float field_71079_bU

    - #### field_71082_cx

          public float field_71082_cx

    - #### field_71089_bV

          public float field_71089_bV

    - #### capabilities

          public PlayerCapabilities capabilities

      The player's capabilities. (See class PlayerCapabilities)

    - #### experienceLevel

          public int experienceLevel

      The current experience level the player is on.

    - #### experienceTotal

          public int experienceTotal

      The total amount of experience the player has. This also includes the amount of experience within their Experience Bar.

    - #### experience

          public float experience

      The current amount of experience the player has within their Experience Bar.

    - #### fishEntity

          public EntityFishHook fishEntity

      An instance of a fishing rod's hook. If this isn't null, the icon image of the fishing rod is slightly different

    - #### eyeHeight

          public float eyeHeight

  - ### Constructor Detail

    - #### EntityPlayer

          public EntityPlayer(World par1World,
                      String par2Str)

  - ### Method Detail

    - #### getItemInUse

          public ItemStack getItemInUse()

    - #### getItemInUseCount

          public int getItemInUseCount()

    - #### isUsingItem

          public boolean isUsingItem()

      Checks if the entity is currently using an item (e.g., bow, food, sword) by holding down the useItemButton

    - #### getItemInUseDuration

          public int getItemInUseDuration()

    - #### stopUsingItem

          public void stopUsingItem()

    - #### clearItemInUse

          public void clearItemInUse()

    - #### isBlocking

          public boolean isBlocking()

    - #### onUpdate

          public void onUpdate()

      Called to update the entity's position/logic.
      Overrides:
        `onUpdate` in class `EntityLivingBase`

    - #### getMaxInPortalTime

          public int getMaxInPortalTime()

      Return the amount of time this entity should stay in a portal before being transported.
      Overrides:
        `getMaxInPortalTime` in class `Entity`

    - #### getPortalCooldown

          public int getPortalCooldown()

      Return the amount of cooldown before this entity can use a portal again.
      Overrides:
        `getPortalCooldown` in class `Entity`

    - #### playSound

          public void playSound(String par1Str,
                       float par2,
                       float par3)

      Overrides:
        `playSound` in class `Entity`

    - #### handleHealthUpdate

          public void handleHealthUpdate(byte par1)

      Overrides:
        `handleHealthUpdate` in class `EntityLivingBase`

    - #### closeScreen

          public void closeScreen()

      sets current screen to null (used on escape buttons of GUIs)

    - #### mountEntity

          public void mountEntity(Entity par1Entity)

      Called when a player mounts an entity. e.g. mounts a pig, mounts a boat.
      Overrides:
        `mountEntity` in class `Entity`

    - #### updateRidden

          public void updateRidden()

      Handles updating while being ridden by an entity
      Overrides:
        `updateRidden` in class `EntityLivingBase`

    - #### preparePlayerToSpawn

          public void preparePlayerToSpawn()

    - #### onLivingUpdate

          public void onLivingUpdate()

      Called frequently so the entity can update its state every tick as required. For example, zombies and skeletons use this to react to sunlight and start to burn.
      Overrides:
        `onLivingUpdate` in class `EntityLivingBase`

    - #### getScore

          public int getScore()

    - #### setScore

          public void setScore(int par1)

      Set player's score

    - #### addScore

          public void addScore(int par1)

      Add to player's score

    - #### onDeath

          public void onDeath(DamageSource par1DamageSource)

      Called when the mob's health reaches 0.
      Overrides:
        `onDeath` in class `EntityLivingBase`

    - #### addToPlayerScore

          public void addToPlayerScore(Entity par1Entity,
                              int par2)

      Adds a value to the player score. Currently not actually used and the entity passed in does nothing. Args: entity, scoreToAdd
      Overrides:
        `addToPlayerScore` in class `Entity`

    - #### dropOneItem

          public EntityItem dropOneItem(boolean par1)

      Called when player presses the drop item key

    - #### dropPlayerItem

          public EntityItem dropPlayerItem(ItemStack par1ItemStack)

      Args: itemstack - called when player drops an item stack that's not in his inventory (like items still placed in a workbench while the workbench'es GUI gets closed)

    - #### dropPlayerItemWithRandomChoice

          public EntityItem dropPlayerItemWithRandomChoice(ItemStack par1ItemStack,
                                                  boolean par2)

      Args: itemstack, flag

    - #### joinEntityItemWithWorld

          public void joinEntityItemWithWorld(EntityItem par1EntityItem)

      Joins the passed in entity item with the world. Args: entityItem

    - #### getCurrentPlayerStrVsBlock

          @Deprecated
          public float getCurrentPlayerStrVsBlock(Block par1Block,
                                                    boolean par2)

      Deprecated.
      Returns how strong the player is against the specified block at this moment Deprecated in favor of the more sensitive version

    - #### getCurrentPlayerStrVsBlock

          public float getCurrentPlayerStrVsBlock(Block par1Block,
                                         boolean par2,
                                         int meta)

    - #### canHarvestBlock

          public boolean canHarvestBlock(Block par1Block)

      Checks if the player has the ability to harvest a block (checks current inventory item for a tool if necessary)

    - #### readEntityFromNBT

          public void readEntityFromNBT(NBTTagCompound par1NBTTagCompound)

      (abstract) Protected helper method to read subclass entity data from NBT.
      Overrides:
        `readEntityFromNBT` in class `EntityLivingBase`

    - #### writeEntityToNBT

          public void writeEntityToNBT(NBTTagCompound par1NBTTagCompound)

      (abstract) Protected helper method to write subclass entity data to NBT.
      Overrides:
        `writeEntityToNBT` in class `EntityLivingBase`

    - #### displayGUIChest

          public void displayGUIChest(IInventory par1IInventory)

      Displays the GUI for interacting with a chest inventory. Args: chestInventory

    - #### displayGUIHopper

          public void displayGUIHopper(TileEntityHopper par1TileEntityHopper)

    - #### displayGUIHopperMinecart

          public void displayGUIHopperMinecart(EntityMinecartHopper par1EntityMinecartHopper)

    - #### displayGUIHorse

          public void displayGUIHorse(EntityHorse par1EntityHorse,
                             IInventory par2IInventory)

    - #### displayGUIEnchantment

          public void displayGUIEnchantment(int par1,
                                   int par2,
                                   int par3,
                                   String par4Str)

    - #### displayGUIAnvil

          public void displayGUIAnvil(int par1,
                             int par2,
                             int par3)

      Displays the GUI for interacting with an anvil.

    - #### displayGUIWorkbench

          public void displayGUIWorkbench(int par1,
                                 int par2,
                                 int par3)

      Displays the crafting GUI for a workbench.

    - #### getEyeHeight

          public float getEyeHeight()

      Overrides:
        `getEyeHeight` in class `EntityLivingBase`

    - #### attackEntityFrom

          public boolean attackEntityFrom(DamageSource par1DamageSource,
                                 float par2)

      Called when the entity is attacked.
      Overrides:
        `attackEntityFrom` in class `EntityLivingBase`

    - #### canAttackPlayer

          public boolean canAttackPlayer(EntityPlayer par1EntityPlayer)

    - #### getTotalArmorValue

          public int getTotalArmorValue()

      Returns the current armor value as determined by a call to InventoryPlayer.getTotalArmorValue
      Overrides:
        `getTotalArmorValue` in class `EntityLivingBase`

    - #### getArmorVisibility

          public float getArmorVisibility()

      When searching for vulnerable players, if a player is invisible, the return value of this is the chance of seeing them anyway.

    - #### displayGUIFurnace

          public void displayGUIFurnace(TileEntityFurnace par1TileEntityFurnace)

      Displays the furnace GUI for the passed in furnace entity. Args: tileEntityFurnace

    - #### displayGUIDispenser

          public void displayGUIDispenser(TileEntityDispenser par1TileEntityDispenser)

      Displays the dipsenser GUI for the passed in dispenser entity. Args: TileEntityDispenser

    - #### displayGUIEditSign

          public void displayGUIEditSign(TileEntity par1TileEntity)

      Displays the GUI for editing a sign. Args: tileEntitySign

    - #### displayGUIBrewingStand

          public void displayGUIBrewingStand(TileEntityBrewingStand par1TileEntityBrewingStand)

      Displays the GUI for interacting with a brewing stand.

    - #### displayGUIBeacon

          public void displayGUIBeacon(TileEntityBeacon par1TileEntityBeacon)

      Displays the GUI for interacting with a beacon.

    - #### displayGUIMerchant

          public void displayGUIMerchant(IMerchant par1IMerchant,
                                String par2Str)

    - #### displayGUIBook

          public void displayGUIBook(ItemStack par1ItemStack)

      Displays the GUI for interacting with a book.

    - #### interactWith

          public boolean interactWith(Entity par1Entity)

    - #### getCurrentEquippedItem

          public ItemStack getCurrentEquippedItem()

      Returns the currently being used item by the player.

    - #### destroyCurrentEquippedItem

          public void destroyCurrentEquippedItem()

      Destroys the currently equipped item from the player's inventory.

    - #### getYOffset

          public double getYOffset()

      Returns the Y Offset of this entity.
      Overrides:
        `getYOffset` in class `Entity`

    - #### attackTargetEntityWithCurrentItem

          public void attackTargetEntityWithCurrentItem(Entity par1Entity)

      Attacks for the player the targeted entity with the currently equipped item. The equipped item has hitEntity called on it. Args: targetEntity

    - #### onCriticalHit

          public void onCriticalHit(Entity par1Entity)

      Called when the player performs a critical hit on the Entity. Args: entity that was hit critically

    - #### onEnchantmentCritical

          public void onEnchantmentCritical(Entity par1Entity)

    - #### respawnPlayer

          public void respawnPlayer()

    - #### setDead

          public void setDead()

      Will get destroyed next tick.
      Overrides:
        `setDead` in class `Entity`

    - #### isEntityInsideOpaqueBlock

          public boolean isEntityInsideOpaqueBlock()

      Checks if this entity is inside of an opaque block
      Overrides:
        `isEntityInsideOpaqueBlock` in class `Entity`

    - #### sleepInBedAt

          public EnumStatus sleepInBedAt(int par1,
                                int par2,
                                int par3)

      Attempts to have the player sleep in a bed at the specified location.

    - #### wakeUpPlayer

          public void wakeUpPlayer(boolean par1,
                          boolean par2,
                          boolean par3)

      Wake up the player if they're sleeping.

    - #### verifyRespawnCoordinates

          public static ChunkCoordinates verifyRespawnCoordinates(World par0World,
                                                  ChunkCoordinates par1ChunkCoordinates,
                                                  boolean par2)

      Ensure that a block enabling respawning exists at the specified coordinates and find an empty space nearby to spawn.

    - #### getBedOrientationInDegrees

          public float getBedOrientationInDegrees()

    - #### isPlayerSleeping

          public boolean isPlayerSleeping()

      Returns whether player is sleeping or not
      Overrides:
        `isPlayerSleeping` in class `EntityLivingBase`

    - #### isPlayerFullyAsleep

          public boolean isPlayerFullyAsleep()

      Returns whether or not the player is asleep and the screen has fully faded.

    - #### getSleepTimer

          public int getSleepTimer()

    - #### addChatMessage

          public void addChatMessage(String par1Str)

      Add a chat message to the player

    - #### getBedLocation

          @Deprecated
          public ChunkCoordinates getBedLocation()

      Deprecated.
      Returns the location of the bed the player will respawn at, or null if the player has not slept in a bed.

    - #### isSpawnForced

          @Deprecated
          public boolean isSpawnForced()

      Deprecated.

    - #### getBedLocation

          public ChunkCoordinates getBedLocation(int dimension)

      A dimension aware version of getBedLocation.
      Parameters:
        `dimension` - The dimension to get the bed spawn for
      Returns:
        The player specific spawn location for the dimension. May be null.

    - #### isSpawnForced

          public boolean isSpawnForced(int dimension)

      A dimension aware version of isSpawnForced. Noramally isSpawnForced is used to determine if the respawn system should check for a bed or not. This just extends that to be dimension aware.
      Parameters:
        `dimension` - The dimension to get whether to check for a bed before spawning for
      Returns:
        The player specific spawn location for the dimension. May be null.

    - #### setSpawnChunk

          public void setSpawnChunk(ChunkCoordinates par1ChunkCoordinates,
                           boolean par2)

      Defines a spawn coordinate to player spawn. Used by bed after the player sleep on it.

    - #### setSpawnChunk

          public void setSpawnChunk(ChunkCoordinates chunkCoordinates,
                           boolean forced,
                           int dimension)

      A dimension aware version of setSpawnChunk. This functions identically, but allows you to specify which dimension to affect, rather than affecting the player's current dimension.
      Parameters:
        `chunkCoordinates` - The spawn point to set as the player-specific spawn point for the dimension
        `forced` - Whether or not the respawn code should check for a bed at this location (true means it won't check for a bed)
        `dimension` - Which dimension to apply the player-specific respawn point to

    - #### triggerAchievement

          public void triggerAchievement(StatBase par1StatBase)

      Will trigger the specified trigger.

    - #### addStat

          public void addStat(StatBase par1StatBase,
                     int par2)

      Adds a value to a statistic field.

    - #### moveEntityWithHeading

          public void moveEntityWithHeading(float par1,
                                   float par2)

      Moves the entity based on the specified heading. Args: strafe, forward
      Overrides:
        `moveEntityWithHeading` in class `EntityLivingBase`

    - #### getAIMoveSpeed

          public float getAIMoveSpeed()

      the movespeed used for the new AI system
      Overrides:
        `getAIMoveSpeed` in class `EntityLivingBase`

    - #### addMovementStat

          public void addMovementStat(double par1,
                             double par3,
                             double par5)

      Adds a value to a movement statistic field - like run, walk, swin or climb.

    - #### onKillEntity

          public void onKillEntity(EntityLivingBase par1EntityLivingBase)

      This method gets called when the entity kills another one.
      Overrides:
        `onKillEntity` in class `Entity`

    - #### setInWeb

          public void setInWeb()

      Sets the Entity inside a web block.
      Overrides:
        `setInWeb` in class `Entity`

    - #### getItemIcon

          public Icon getItemIcon(ItemStack par1ItemStack,
                         int par2)

      Overrides:
        `getItemIcon` in class `EntityLivingBase`

    - #### getCurrentArmor

          public ItemStack getCurrentArmor(int par1)

    - #### addExperience

          public void addExperience(int par1)

      This method increases the player's current amount of experience.

    - #### addExperienceLevel

          public void addExperienceLevel(int par1)

      Add experience levels to this player.

    - #### xpBarCap

          public int xpBarCap()

      This method returns the cap amount of experience that the experience bar can hold. With each level, the experience cap on the player's experience bar is raised by 10.

    - #### addExhaustion

          public void addExhaustion(float par1)

      increases exhaustion level by supplied amount

    - #### getFoodStats

          public FoodStats getFoodStats()

      Returns the player's FoodStats object.

    - #### canEat

          public boolean canEat(boolean par1)

    - #### shouldHeal

          public boolean shouldHeal()

      Checks if the player's health is not full and not zero.

    - #### setItemInUse

          public void setItemInUse(ItemStack par1ItemStack,
                          int par2)

      sets the itemInUse when the use item button is clicked. Args: itemstack, int maxItemUseDuration

    - #### isCurrentToolAdventureModeExempt

          public boolean isCurrentToolAdventureModeExempt(int par1,
                                                 int par2,
                                                 int par3)

      Returns true if the given block can be mined with the current tool in adventure mode.

    - #### canPlayerEdit

          public boolean canPlayerEdit(int par1,
                              int par2,
                              int par3,
                              int par4,
                              ItemStack par5ItemStack)

    - #### getEntityName

          public String getEntityName()

      Gets the username of the entity.
      Overrides:
        `getEntityName` in class `Entity`

    - #### getAlwaysRenderNameTagForRender

          public boolean getAlwaysRenderNameTagForRender()

      Overrides:
        `getAlwaysRenderNameTagForRender` in class `EntityLivingBase`

    - #### clonePlayer

          public void clonePlayer(EntityPlayer par1EntityPlayer,
                         boolean par2)

      Copies the values from the given player into this player if boolean par2 is true. Always clones Ender Chest Inventory.

    - #### sendPlayerAbilities

          public void sendPlayerAbilities()

      Sends the player's abilities to the server (if there is one).

    - #### setGameType

          public void setGameType(EnumGameType par1EnumGameType)

      Sets the player's game mode and sends it to them.

    - #### getCommandSenderName

          public String getCommandSenderName()

      Gets the name of this command sender (usually username, but possibly "Rcon")
      Specified by:
        `getCommandSenderName` in interface `ICommandSender`

    - #### getEntityWorld

          public World getEntityWorld()

      Specified by:
        `getEntityWorld` in interface `ICommandSender`

    - #### getInventoryEnderChest

          public InventoryEnderChest getInventoryEnderChest()

      Returns the InventoryEnderChest of this player.

    - #### getCurrentItemOrArmor

          public ItemStack getCurrentItemOrArmor(int par1)

      0 = item, 1-n is armor
      Specified by:
        `getCurrentItemOrArmor` in class `EntityLivingBase`

    - #### getHeldItem

          public ItemStack getHeldItem()

      Returns the item that this EntityLiving is holding, if any.
      Specified by:
        `getHeldItem` in class `EntityLivingBase`

    - #### setCurrentItemOrArmor

          public void setCurrentItemOrArmor(int par1,
                                   ItemStack par2ItemStack)

      Sets the held item, or an armor slot. Slot 0 is held item. Slot 1-4 is armor. Params: Item, slot
      Specified by:
        `setCurrentItemOrArmor` in class `EntityLivingBase`

    - #### isInvisibleToPlayer

          public boolean isInvisibleToPlayer(EntityPlayer par1EntityPlayer)

      Overrides:
        `isInvisibleToPlayer` in class `Entity`

    - #### getLastActiveItems

          public ItemStack[] getLastActiveItems()

      Specified by:
        `getLastActiveItems` in class `EntityLivingBase`

    - #### getHideCape

          public boolean getHideCape()

    - #### isPushedByWater

          public boolean isPushedByWater()

      Overrides:
        `isPushedByWater` in class `Entity`

    - #### getWorldScoreboard

          public Scoreboard getWorldScoreboard()

    - #### getTeam

          public Team getTeam()

      Overrides:
        `getTeam` in class `EntityLivingBase`

    - #### getTranslatedEntityName

          public String getTranslatedEntityName()

      Returns the translated name of the entity.
      Overrides:
        `getTranslatedEntityName` in class `Entity`

    - #### setAbsorptionAmount

          public void setAbsorptionAmount(float par1)

      Overrides:
        `setAbsorptionAmount` in class `EntityLivingBase`

    - #### getAbsorptionAmount

          public float getAbsorptionAmount()

      Overrides:
        `getAbsorptionAmount` in class `EntityLivingBase`

    - #### openGui

          public void openGui(Object mod,
                     int modGuiId,
                     World world,
                     int x,
                     int y,
                     int z)

    - #### getDefaultEyeHeight

          public float getDefaultEyeHeight()

      Returns the default eye height of the player
      Returns:
        player default eye height

    - #### getDisplayName

          public String getDisplayName()

      Get the currently computed display name, cached for efficiency.
      Returns:
        the current display name

    - #### refreshDisplayName

          public void refreshDisplayName()

      Force the displayed name to refresh